/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2013                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef SYSTEMBOXPLOT_H
#define SYSTEMBOXPLOT_H

#include <QWidget>

#include "BoxPlot.h"
#include "SystemTreeWidget.h"
#include "ValueWidget.h"

class SystemBoxPlot : public BoxPlot
{
public:
    SystemBoxPlot( QWidget*,
                   SystemTreeWidget* );
    void
    updateValues();
    void
    updateValueWidget();

    int
    getOptimalWidth()
    {
        return 400;
    };

private:
    Item
    calculateStatistics( bool absolute );

    SystemTreeWidget* systemTreeWidget; // contains data to display
    ValueWidget*      valueWidget;
};

#endif // SYSTEMBOXPLOT_H
