/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2013                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef TEXTTABLE_H
#define TEXTTABLE_H

#include <QtGui>
#include <QStringList>
#include <QList>

class TableWidget : public QWidget
{
    Q_OBJECT
public:
    TableWidget( const QStringList &columns,
                 bool               isTooltip );
    void
    paintEvent( QPaintEvent* );

    virtual QSize
    sizeHint() const
    {
        return size;
    }

    static QDialog*
    showInToolTip( QWidget*           parent,
                   const QPoint &     pos,
                   const QStringList &cols );

    static void
    showInWindow( QWidget*           parent,
                  const QString &    title,
                  const QString &    label,
                  const QStringList &cols );

private slots:
    void
    toClipboard();

private:
    QWidget*    parent;
    QStringList columns;
    bool        first;
    bool        isTooltip;
    QSize       size;
};

#endif // TEXTTABLE_H
