/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2011-2013                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2011-2013                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

package scalasca.cubex.cube;

public enum MetricType
{
	UNKNOWN    (-1 ) { public String toString() { return "UNKNOWN";   }	},
	EXCLUSIVE  ( 0 ) { public String toString() { return "EXCLUSIVE"; } 	},
	INCLUSIVE   ( 1 ){ public String toString() { return "INCLUSIVE"; }	},
	DERIVED     ( 2 ){ public String toString() { return "DERIVED"; }	};

	private final int value;
	MetricType(int value) { this.value = value; }

	abstract public String toString();

	static public MetricType getMetricType(String value)
	{
		if (value == null)			 return MetricType.EXCLUSIVE; // null from cube3 parsing
		if (value.equalsIgnoreCase("UNKNOWN"))   return MetricType.UNKNOWN;
		if (value.equalsIgnoreCase("INCLUSIVE")) return MetricType.INCLUSIVE;
		if (value.equalsIgnoreCase("EXCLUSIVE")) return MetricType.EXCLUSIVE;
		if (value.equalsIgnoreCase("DERIVED")) return MetricType.DERIVED;
		if (value.equalsIgnoreCase(""))  	 return MetricType.EXCLUSIVE;
		return MetricType.UNKNOWN;
	}




}


