/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2011-2013                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2011-2013                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

package scalasca.cubex.cube.services;
import java.lang.String;
import java.util.ArrayList;
import java.util.HashMap;
import scalasca.cubex.cube.*;



/*
 * Class , delivers file structure of CubeX
 * 
 */
public class CnodesDeepEnumeration extends CnodesEnumeration
{
	protected String name = "Deep Enumeration (Deep First seatch)";

	public CnodesDeepEnumeration(ArrayList<scalasca.cubex.cube.Cnode> root_cnodes)
	{
		enumerate(root_cnodes);
	}


	protected void enumerate(ArrayList<scalasca.cubex.cube.Cnode> root_cnodes)
	{
		
		ArrayList<scalasca.cubex.cube.Cnode> _cnodes = make_list(root_cnodes);
		for (int i = 0; i<_cnodes.size(); i++)
		{
			enumeration.put(_cnodes.get(i), new Integer(i));
		}
	}


	protected ArrayList<scalasca.cubex.cube.Cnode> make_list(ArrayList<scalasca.cubex.cube.Cnode> root_cnodes)
	{
		ArrayList<scalasca.cubex.cube.Cnode> _list = new ArrayList<scalasca.cubex.cube.Cnode>();

		for (int i = 0; i<root_cnodes.size(); i++)
		{
			addToList(_list, root_cnodes.get(i));
		}
		return _list;
	}


	private void addToList(ArrayList<scalasca.cubex.cube.Cnode> _list, scalasca.cubex.cube.Cnode 	cnode)
	{
		_list.add(cnode);
		ArrayList<scalasca.cubex.cube.Vertex> _children = cnode.getAllChildren();
		for (int i = 0; i<_children.size(); i++)
		{
			addToList(_list, (scalasca.cubex.cube.Cnode)(_children.get(i)));
		}
	}
}
