/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2011-2013                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2011-2013                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

package scalasca.cubex.cube.services;
import java.lang.String;
import java.util.ArrayList;
import java.util.HashMap;
import scalasca.cubex.cube.*;
import scalasca.cubex.cube.services.*;




/*
 * Class , delivers file structure of CubeX
 * 
 */
public class CnodesWideEnumeration extends CnodesEnumeration
{
	protected String name = "Wide Enumeration (Bridth First seatch)";
// 	protected idx = 0; // used in the enumeration prescription. global over function calls

	public CnodesWideEnumeration(ArrayList<scalasca.cubex.cube.Cnode> root_cnodes)
	{
		enumerate(root_cnodes);
	}


	protected void enumerate(ArrayList<scalasca.cubex.cube.Cnode> root_cnodes)
	{
		
		ArrayList<scalasca.cubex.cube.Cnode> _cnodes = make_list(root_cnodes);
		for (int i = 0; i<_cnodes.size(); i++)
		{
			enumeration.put(_cnodes.get(i), new Integer(i));
		}
	}


	protected ArrayList<scalasca.cubex.cube.Cnode> make_list(ArrayList<scalasca.cubex.cube.Cnode> root_cnodes)
	{
		ArrayList<scalasca.cubex.cube.Cnode> _list = new ArrayList<scalasca.cubex.cube.Cnode>();

		int adder_cnode_index = 0;
// 		id = 0;
		for (int i = 0; i<root_cnodes.size(); i++)
		{
			add_to_list(_list, root_cnodes.get(i) );
// 			_list.add(root_cnodes.get(i));
		}
/*

		while(adder_cnode_index < _list.size())
		{
			scalasca.cubex.cube.Cnode _cnode = _list.get(adder_cnode_index );
			ArrayList<scalasca.cubex.cube.Vertex> _children_list = _cnode.getAllChildren();
			for (int i = 0; i<_children_list.size(); i++)
			{
				_list.add((scalasca.cubex.cube.Cnode)_children_list.get(i));
			}
			adder_cnode_index++;
		}*/
		return _list;
	}

	private void add_to_list(ArrayList<scalasca.cubex.cube.Cnode> _list, scalasca.cubex.cube.Cnode _cnode)
	{
	    if (_cnode == null) return;
	    if (_cnode.getParent() == null)
	    {
		_list.add(_cnode);
	    }
	    for (scalasca.cubex.cube.Vertex _child : _cnode.getAllChildren())
	    {
		_list.add((scalasca.cubex.cube.Cnode)_child);
	    }	
	    for (scalasca.cubex.cube.Vertex _child : _cnode.getAllChildren())
	    {
		add_to_list(_list, (scalasca.cubex.cube.Cnode)_child);
	    }		    
	}	
}
