/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2011-2013                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2011-2013                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

package scalasca.cubex.cube.services.transformation;
import java.lang.*;
import java.math.BigInteger;
/*
 * Class , delivers file structure of CubeX
 * 
 */
public class SwapBytes extends Endianess
{

	public SwapBytes () {}

	public char 	applyOn(char a)
			{
				return (char)(Short.reverseBytes((short)a));
			}

	public byte 	applyOn(byte a)		{ return a; }
	public short 	applyOn(short a)
			{
				return Short.reverseBytes(a);
			}

	public int   	applyOn(int a)		
			{

				return Integer.reverseBytes(a);
			}
	public long	applyOn(long a)
			{
				return Long.reverseBytes(a);
			}
 
	public double	applyOn(double a)
			{
				long _a = Double.doubleToLongBits(a);
				long __a =  Long.reverseBytes(_a);
				return Double.longBitsToDouble(__a);
			}

	public Byte	applyOn(Byte a	)	{ return a; }
	public Short	applyOn(Short a)
				{
					return new Short(applyOn(a.shortValue()));
				}
	public Integer	applyOn(Integer a)
				{
					return new Integer(applyOn(a.intValue()));
				}

	public Long	applyOn(Long a)
				{
					return new Long(applyOn(a.longValue()));
				}
	public Double	applyOn(Double a)
				{
					return new Double(applyOn(a.doubleValue()));
				}
	public byte[]	applyOn(byte[] a )
				{

					byte[] aa  = new byte[a.length];
					System.arraycopy(a, 0, aa, 0, a.length);
					int mid_index = aa.length/2;
					for (int i=0; i<mid_index; i++)
					{
						byte _tmp =aa[i];
						aa[i] = aa[aa.length-1 - i];
						aa[aa.length-1 - i] = _tmp;
					}
					return aa;
				}


}
