#! /bin/sh
##*************************************************************************##
##  CUBE        http://www.score-p.org/                                    ##
##  SCALASCA    http://www.scalasca.org/                                   ##
##*************************************************************************##
##  Copyright (c) 1998-2013                                                ##
##  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          ##
##                                                                         ##
##  Copyright (c) 2009-2013                                                ##
##  German Research School for Simulation Sciences GmbH,                   ##
##  Laboratory for Parallel Programming                                    ##
##                                                                         ##
##  This software may be modified and distributed under the terms of       ##
##  a BSD-style license.  See the COPYING file in the package base         ##
##  directory for details.                                                 ##
##*************************************************************************##

# this script expects an input that contains at least these lines specifying
# the package version, e.g.
# package.major=0
# package.minor=9
# package.bugfix=0
# package.suffix=

format="${2-}"

major=0
minor=0
bugfix=0
suffix=

errormsg=
atexit_error()
{
    if test -n "$errormsg"
    then
        printf "%s\n" "$errormsg"
    fi
}
trap atexit_error EXIT

errormsg="$(printf "Malformed VERSION file: %s" "$1")"
set -e
eval "$(sed -n -e 's/^package\.// p' "$1")"
errormsg=

if test -z "$format"
then
    suffix="${suffix:+-}${suffix}"
    if test "$bugfix" -eq 0
    then
        printf "%d.%d%s" "$major" "$minor" "$suffix"
    else
        printf "%d.%d.%d%s" "$major" "$minor" "$bugfix" "$suffix"
    fi
    if test -t 1
    then
        printf "\n"
    fi
else
    eval "$format"
fi
