## -*- mode: autoconf -*-
##*************************************************************************##
##  CUBE        http://www.score-p.org/                                    ##
##  SCALASCA    http://www.scalasca.org/                                   ##
##*************************************************************************##
##  Copyright (c) 1998-2013                                                ##
##  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          ##
##                                                                         ##
##  Copyright (c) 2009-2013                                                ##
##  German Research School for Simulation Sciences GmbH,                   ##
##  Laboratory for Parallel Programming                                    ##
##                                                                         ##
##  This software may be modified and distributed under the terms of       ##
##  a BSD-style license.  See the COPYING file in the package base         ##
##  directory for details.                                                 ##
##*************************************************************************##

AC_DEFUN([AC_SCOREP_JAVA_READER_OPTION],
[
JAVAC_AVAILABLE="yes"
JAR_AVAILABLE="yes"
JXERCES="yes"





AS_IF([ test "x$WITH_JAVA_READER" = "xyes"], [
  AC_SCOREP_JAVA_CHECKS
  AS_IF([ test "x$WITH_JAVA_READER" = "xyes" ],[
    JXERCES="yes"
    AC_SCOREP_XERCES_CHECK
    AS_IF([test "x$JXERCES" = "x"], [
    JXERCES="no"
    WITH_JAVA_READER="no"
])
])
])


AC_SUBST([JAVACPATH])
AC_SUBST([JAVACVERSION])
AC_SUBST([JAVAPATH])
AC_SUBST([JARPATH])
AC_SUBST([WITH_JAVA_READER])


])


AC_DEFUN([AC_SCOREP_WITH_JAVA],
[

if test "x${JAVAC}" = "x"; then
    AC_CHECK_PROGS(JAVAC, javac gcj, "")   
fi


#if test "x${JAVA}" = "x"; then
#    AC_CHECK_PROGS(JAVA, java , "")
#
#fi

if test "x${JAR}" = "x"; then
    AC_CHECK_PROGS(JAR, jar, "")
fi



if test "x$JAVAC" != "x"; then
    JAVAC_AVAILABLE="yes"
    JAVACVERSION=`javac -version 2>&1 `
    AS_IF([test "x$?" != "x0"],[
    JAVACVERSION=
    ])
    JAVACPATH=`which $JAVAC`
else
    JAVAC_AVAILABLE="no"
    WITH_JAVA_READER="no"
fi

#if test "x$JAVA" != "x"; then
#    JAVA_AVAILABLE="yes"
#    JAVAPATH=`which $JAVA`
#else
#    JAVA_AVAILABLE="no"
#    WITH_JAVA_READER="no"
#fi

if test "x$JAR" != "x"; then
    JAR_AVAILABLE="yes"
    JARPATH=`which $JAR`
else
    JAR_AVAILABLE="no"
    WITH_JAVA_READER="no"
fi





])







AC_DEFUN([AC_SCOREP_JAVA_CHECKS], [

#AM_PROG_GCJ
AC_SCOREP_WITH_JAVA

])





AC_DEFUN([AC_SCOREP_XERCES_CHECK], [

jars="$XERCES_NAME xerces2-j.jar xerces-j2.jar xercesImpl.jar"
path="$XERCES_PATH$PATH_SEPARATOR$CLASSPATH$PATH_SEPARATOR."

if test "x$XERCES_NAME" != "xxerces.jar"; then
jars="$jars xerces.jar"
fi
if test "x$XERCES_PATH" != "x/usr/share/java"; then
path="$path$PATH_SEPARATOR/usr/share/java"
fi



_path=`echo $path | sed -e "s,$PATH_SEPARATOR, ,g"`
JXERCES=
JXERCES_FULL=
for jar in $jars; do
for __path in $_path; do
AC_MSG_CHECKING([Looking for  $jar in "$__path" ])
if test -f $__path/$jar; then
AC_MSG_RESULT([found])
  JXERCES=$jar
  JXERCES_FULL=$__path/$jar
  break;
else
AC_MSG_RESULT([no])
fi
done
if test "x$JXERCES" != "x"; then
    break;
fi
done
if test "x$JXERCES" == "x"; then 
AC_MSG_NOTICE([ Didn't find any SAX parser implementations ( $jars ) - disable java reader.])
    WITH_JAVA_READER="no"
    break;
fi


AC_SUBST(JXERCES_FULL)

])


