## -*- mode: autoconf -*-
##*************************************************************************##
##  CUBE        http://www.score-p.org/                                    ##
##  SCALASCA    http://www.scalasca.org/                                   ##
##*************************************************************************##
##  Copyright (c) 1998-2013                                                ##
##  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          ##
##                                                                         ##
##  Copyright (c) 2009-2013                                                ##
##  German Research School for Simulation Sciences GmbH,                   ##
##  Laboratory for Parallel Programming                                    ##
##                                                                         ##
##  This software may be modified and distributed under the terms of       ##
##  a BSD-style license.  See the COPYING file in the package base         ##
##  directory for details.                                                 ##
##*************************************************************************##


AC_DEFUN([AC_SCOREP_QT_COMPILER_COMPATIBILITY_CHECK],
[
found=""

MKSPECS=`$QMAKE -query | grep "QMAKE_MKSPECS:" | sed -e 's,QMAKE_MKSPECS:,,g'`

if test "x$MKSPECS" == "x"; then
    if test -d /usr/share/qt/mkspecs; then
	MKSPECS="/usr/share/qt/mkspecs"
    fi
    if test -d /usr/share/qt4/mkspecs;  then
	MKSPECS="/usr/share/qt4/mkspecs"
    fi
    if test -d /opt/qt/mkspecs;  then
	MKSPECS="/opt/qt/mkspecs"
    fi
    if test -d /opt/qt4/mkspecs;  then
	MKSPECS="/opt/qt4/mkspecs"
    fi
    if test -d /usr/local/share/qt/mkspecs;  then
	MKSPECS="/usr/local/share/qt/mkspecs"
    fi
    if test -d /usr/local/share/qt4/mkspecs;  then
	MKSPECS="/usr/local/share/qt4/mkspecs"
    fi
    if test -d /usr/local/Trolltech/mkspecs;  then
	MKSPECS="/usr/local/Trolltech/mkspecs"
    fi
    if test -d /usr/local/Trolltech/mkspecs;  then
	MKSPECS="/usr/local/Trolltech/mkspecs"
    fi
fi
spec_file=`readlink -n $MKSPECS/$QT_SPECS`

#in the case, QT_SPECS is defined and is not links
if test "x$spec_file" == "x"; then
spec_file=$QT_SPECS
fi

cxx_compiler=`cat $MKSPECS/$spec_file/qmake.conf | grep -e  'QMAKE_CXX\W' | $AWK  '{ print $ 3 }'`

if test "x$cxx_compiler" == "x"; then
    #seems that it has include()

    include1=`cat $MKSPECS/$spec_file/qmake.conf | grep -e "include(" | sed -e 's,include(,,' -e 's,),,g'`
    for _file in $include1; do
	cxx_compiler1=`cat $MKSPECS/$spec_file/$_file | grep  '^QMAKE_CXX\W'| $AWK '{ print $ 3 }'`
	    if test "x$cxx_compiler1" == "x"; then

		include2=`cat $MKSPECS/$spec_file/$_file | grep -e "include(" | sed -e 's,include(,,' -e 's,),,g'`
		for _file1 in $include2; do
		    diroffile=`dirname $MKSPECS/$spec_file/$_file`
		    cxx_compiler2=`cat $diroffile/$_file1 | grep -E  'QMAKE_CXX\W' | $AWK  '{ print $ 3 }'`
		    if test "x$cxx_compiler2" != "x"; then
                cxx_compiler1=$cxx_compiler2
                found="yes"
		    fi
		    if test "x$found" == "xyes"; then cxx_compiler=$cxx_compiler1;break; fi
		done
	    else
		cxx_compiler=$cxx_compiler1
		found="yes"
	    fi 
	    if test "x$found" == "xyes"; then cxx_compiler=$cxx_compiler1; break; fi
    done
fi

echo "Found Qt compiler $cxx_compiler"



if test "x$cxx_compiler" != "x$CXX"; then
    AC_MSG_WARN([=============================================================================================================])
    AC_MSG_WARN([You have selected as a compiler $CXX and using QT_SPEC ($spec_file) Qt should be compiled with $cxx_compiler.])
    AC_MSG_WARN([=============================================================================================================])
#    read  -p "sdssssssssssss" answer
#    if test "x$answer" != "xyes"; then
#	exit -1;
#    fi
AC_MSG_NOTICE([Try to test Qt with  $CXX. If it fails, please specify proper frontend compiler using option --with-frontend-compiler-suite.])
else
AC_MSG_NOTICE([Ok. Selected compiler $CXX and Qt compiler $compiler are same.])
fi
])

